# -*- coding: utf-8 -*-
#
# Created on Oct 15, 2013
# @authors: Jiri Spilka, Vaclv Chudacek
# http://bio.felk.cvut.cz/~spilkaj
# 2013, CTU in Prague, FEE, Dept. of Cybernetics
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""
CTGViewerLite
----------------

The CTGViewerLite module provides the plotting for the CTU-UHB database

Reference
~~~~~~~~~~~

.. autoclass:: ctgViewerLite
   :members:
"""

DEBUG_PROFILE = False

# system imports
import sys

from PyQt4 import QtGui
from MainWindow import Main
from Init import init

#conditional import
if DEBUG_PROFILE:
    import cProfile
    import pstats

def main():

    app = QtGui.QApplication(sys.argv)

    #pixmap = QtGui.QPixmap("images/ctgViewerIntro.png")
    #splash = QtGui.QSplashScreen(pixmap)
    #splash.show()
    #splash.showMessage("Loaded modules")
    #app.processEvents()
    init()

    window = Main(sys.argv)

    app.processEvents()

    window.show()
    window.ui.PlotWidget.updatePlots()
    #splash.finish(window)
    #window.setGeometry(50,50,1000,30)

    sys.exit(app.exec_())

if __name__ == '__main__':

    if DEBUG_PROFILE:
        cProfile.run('main()', 'profile_data')
        p = pstats.Stats('profile_data')
        p.sort_stats('time').print_stats(20)
        p.sort_stats('cumulative').print_stats(20)
    else:
        main()