# -*- coding: utf-8 -*-
#
# Created on Oct 15, 2013
# @author: Jiri Spilka
# http://bio.felk.cvut.cz/~spilkaj
# 2013, CTU in Prague, FEE, Dept. of Cybernetics
#
# Licensed under the terms of the GNU GENERAL PUBLIC LICENSE
# (see ctgViewerLite.py for details)

import os
import sys

"""
"static" functions
"""

#_log = logging.getLogger(Config.logger_name)

def ensure_dir(sDir):
    if not os.path.exists(sDir):
        os.makedirs(sDir)

def file_exists(inFile):
    """ check if a file exist """
    if os.path.exists(inFile):
        return True
    else:
        #_log.error("File not exists: {0}".format(inFile))
        return False

def get_filename_with_ext(inFile):
    dummy,file_name_with_ext = os.path.split(inFile)
    return file_name_with_ext

def get_filename_without_ext(inFile):
    file1 = get_filename_with_ext(inFile)
    file_name,dummy = os.path.splitext(file1)
    return file_name

def get_filename_and_ext(inFile):
    file1 = get_filename_with_ext(inFile)
    file_name,ext = os.path.splitext(file1)
    return file_name,ext

def get_number_lines_in_stream(fStream):
    """ count lines in a stream, when done return stream to the beginning of a file """
    lines = 0
    buf_size = 1024 * 1024
    read_f = fStream.read # loop optimization

    buf = read_f(buf_size)
    while buf:
        lines += buf.count('\n')
        buf = read_f(buf_size)

    fStream.seek(0)
    return lines

def get_mumber_lines(filename):
    """ count lines in a file """

    f = open(filename, "r+")
    lines = get_number_lines_in_stream(f)
    f.close()
    return lines

def get_files_with_ext_mask(dir_name,ext_mask):
    """
    get all files in directory with specified extension
    """

    files = directory_listing(dir_name)
    output = []
    for f in files:
        dummy,ext = get_filename_and_ext(f)

        if len(ext) == 0:
            continue

        if ext[0] == '.':
            ext = ext[1:]

        if ext_mask == ext:
            output.append(f)

    return output


def directory_listing(dir_name):
    output = []
    for dirname, dummy, filenames in os.walk(dir_name):
        for filename in filenames:
            output.append(os.path.join(dirname, filename))

    return output

def get_application_path():
    """ determine if application is a script file or frozen exe """
    if getattr(sys, 'frozen', False):
        return os.path.dirname(sys.executable)
    elif __file__:
        return os.path.dirname(__file__)