# -*- coding: utf-8 -*-
#
# Created on Oct 15, 2013
# @author: Jiri Spilka
# http://bio.felk.cvut.cz/~spilkaj
# 2013, CTU in Prague, FEE, Dept. of Cybernetics
#
# Licensed under the terms of the GNU GENERAL PUBLIC LICENSE
# (see ctgViewerLite.py for details)

"""
DataModel
--------------------

NOT FINISHED, TEMPORARY
"""

import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.Qt import *
import Common
from Config import ConfigStatic, ConfigIni, EnumIniVar
from LoadWriteData import LoadData
from DataBrowserUI import Ui_DataBrowser

class DataModel(QWidget):

    def __init__(self, parent  = None, configIni = None):

        QWidget.__init__(self, parent)

        self.ui = Ui_DataBrowser()
        self.ui.setupUi(self)

        # CONFIG
        if configIni is None:
            self._configIni = ConfigIni()

        self._dataLoader = LoadData()

        self._sourceDir = ''
        self._filesExt = 'dat'

        self._model = QStandardItemModel()
        self._table = self.ui.tableView

        self._table.doubleClicked.connect(self._tableDoubleClick)

    def setSourceDir(self, sdir):
        self._sourceDir = sdir

    def getSourceDir(self):
        return self._sourceDir

    def setSourceDirAndLoad(self, sdir):

        self.setSourceDir(sdir)
        aFiles = Common.get_files_with_ext_mask(self._sourceDir,self._filesExt)

        self._setModelForFiles(aFiles)

        self._table.setModel(self._model)
        self._table.sortByColumn(0,0)
        self._table.resizeColumnsToContents()
        self._table.resizeRowsToContents()

        self._tableSettings()

    def _modelSettings(self):
        pass

    def _tableSettings(self):

        self._table.setSortingEnabled(True)
        self._table.setEditTriggers(QAbstractItemView.NoEditTriggers) # disable editting

        # font
        font = self._table.font()
        size = font.pointSize()
        font.setPointSize(size - 2)
        self._table.setFont(font)

        self._table.setSelectionBehavior(QAbstractItemView.SelectRows) # select whole rows

    def _setModelForFiles(self, aFiles):

        nNrFiles = len(aFiles)
        self._selectedAtt = self._configIni.get_var(EnumIniVar.dataBrowserSelectedAttributes)

        self._model = QStandardItemModel(nNrFiles,1)
        for i in range(nNrFiles):
            lHeader,dummy,dummy,dummy = self._dataLoader.readPhysionetHeaderSignalName(aFiles[i])

            file1 = Common.get_filename_without_ext(aFiles[i])
            self._model.setItem(i, 0, QStandardItem(file1))

            dictt = lHeader[2]

            cnt = 1
            for l in self._selectedAtt:
                pH = self.__getValStr(dictt,l)
                self._model.setItem(i, cnt, QStandardItem(pH))
                cnt += 1

        # header
        temp = list()
        temp.append('name')
        self._model.setHorizontalHeaderLabels(temp+self._selectedAtt)

    def __getValStr(self, dictCI, key):
        if key in dictCI:
            return str(dictCI[key])

    def _tableDoubleClick(self):

        print 'double clicked'
        print self._table.selectedIndexes()

        item = self._table.selectedIndexes()
        item = item[0]
        #ileName = self.model.getFileNameIfPresent(nRow)



if __name__ == '__main__':
    app = QApplication(sys.argv)
    dataModel = DataModel()
    dataModel.show()

    dataModel.setSourceDirAndLoad('/home/jirka/data/igabrno/CTU_UHB_physionet')

    sys.exit(app.exec_())