from cx_Freeze import setup, Executable
import os, shutil

## general settings
BASE_DIR = os.path.dirname(__file__)
OUT_DIR = os.path.join(BASE_DIR, 'build')

INNO_SCRIPT = 'setup_inno.iss'
INNO_EXECUTABLE = '"c:\\Program Files\\Inno Setup 5\\ISCC.exe"'

# delete output dir
if os.path.exists(OUT_DIR):
    shutil.rmtree(OUT_DIR)

# Process the includes, excludes and packages first
includefiles = ['win32/vcredist_x86.exe']
includes = []
excludes = ['tcl','Tkinter']
packages = []
path = []

exeTarget = Executable(
    script="CTGViewerLite.py",
    base="Win32GUI",
    compress = True,
    copyDependentFiles = True,
    )

setup(
    name = "CTGViewerLite",
    version = "0.2.1",
    description = "CTGViewerLite application",
    author = "Jiri Spilka",
    author_email='spilka.jiri@fel.cvut.cz',
    url='http://bio.felk.cvut.cz/~spilkaj',
    options = {"build_exe": {"includes": includes,
                             "include_files":includefiles,
                             "excludes": excludes,
                             "packages": packages,
                             "path": path
                             }
               },
    executables = [exeTarget]
    )

os.system(INNO_EXECUTABLE + " " + INNO_SCRIPT)

print('Build complete')
